// ===================================================================
//
// CBP_ePuck_Braitenberg_Light.c
//
// 09-09-20
// Controller for Braitenberg Vehicle
//
// ==================================================================

#include <webots/robot.h>
#include <webots/motor.h> 
#include <stdio.h>
#include <webots/light_sensor.h>
#include <webots/keyboard.h>

//#include "CBP_Helper_3.h"

#define TIME_STEP 32
#define WHEEL_RADIUS 0.0205
#define AXLE_LENGTH 0.053
#define MAX_SPEED 2.28
#define PI 3.14159265358979

WbDeviceTag left_motor, right_motor, back_left_motor, back_right_motor;
WbDeviceTag ls0, ls7;




void deviceInit() {
 // get a handler to the motors and set target position to infinity (speed control).
  left_motor = wb_robot_get_device("motor1");
  right_motor = wb_robot_get_device("motor2");
  back_right_motor = wb_robot_get_device("motor3");
  back_left_motor = wb_robot_get_device("motor4");
  wb_motor_set_position(left_motor, INFINITY);
  wb_motor_set_position(right_motor, INFINITY);
  wb_motor_set_position(back_left_motor, INFINITY);
  wb_motor_set_position(back_right_motor, INFINITY);
  wb_motor_set_velocity(left_motor, 0.0);
  wb_motor_set_velocity(right_motor, 0.0);
   wb_motor_set_velocity(back_left_motor, 0.0);
  wb_motor_set_velocity(back_right_motor, 0.0);

//  ls0 = wb_robot_get_device("ls0");
//  wb_light_sensor_enable(ls0, TIME_STEP); 
//  ls7 = wb_robot_get_device("ls7");
//  wb_light_sensor_enable(ls7, TIME_STEP); 
       
  }  


int main(int argc, char **argv) {

  double omegaL, omegaR;
  double leftEyeVal, rightEyeVal;
  double leftIntens, rightIntens;
  double driveL, driveR;
  
  float M_SPEED = 2.28;
  
  wb_robot_init();
 
   //printf("Hello World!\n");
 
  deviceInit();
  
  enum {
  WB_KEYBOARD_END,
  WB_KEYBOARD_HOME,
  WB_KEYBOARD_LEFT,
  WB_KEYBOARD_UP,
  WB_KEYBOARD_RIGHT,
  WB_KEYBOARD_DOWN,
  WB_KEYBOARD_PAGEUP,
  WB_KEYBOARD_PAGEDOWN,
  WB_KEYBOARD_KEY,
  WB_KEYBOARD_SHIFT,
  WB_KEYBOARD_CONTROL,
  WB_KEYBOARD_ALT
};

  wb_keyboard_enable(TIME_STEP);
  while (wb_robot_step(TIME_STEP) != -1) {
          
 //   leftEyeVal = wb_light_sensor_get_value(ls7);    
 //   rightEyeVal = wb_light_sensor_get_value(ls0);    

 //   leftIntens = invertLightSensorVals(leftEyeVal);
 //   rightIntens = invertLightSensorVals(rightEyeVal);
        
//    printf("leftIntens = %f, rightIntens = %f\n",leftIntens,rightIntens);
      int key = wb_keyboard_get_key();
      //printf("Hello World!\n");
      if (key > 0) 
      {
      
        if (key == 315) {
        printf("Up\n");
        M_SPEED += 0.20;
        } else if (key == 317){
        printf("Down\n");
        M_SPEED -= 0.20;
        } else if (key == 316) {
         printf("right\n");
        } else if (key == 314) {
        printf("left\n");
        }
        //printf("Key: \n", key); 
        printf("pitch = %d\n",wb_keyboard_get_key());
        printf("speed = %f\n",M_SPEED);        
      }; 
    
    /*
        int key = wb_keyboard_get_key();
    //printf(">>>>>>>>> key = %d\n",key);
     
    while (key > 0) {
      switch (key) {
        case WB_KEYBOARD_UP:
          //target_pitch += 1.0*M_PI/180.0;
          printf("pitch = %f\n",key);
          break;
         case WB_KEYBOARD_DOWN:
          //target_pitch -= 1.0*M_PI/180.0;
          printf("pitch = %f\n",key);          
          break;
         case (WB_KEYBOARD_SHIFT + WB_KEYBOARD_UP):
           //thrust += 50;
           printf("thrust: %f\n", key);
           break;
         case (WB_KEYBOARD_SHIFT + WB_KEYBOARD_DOWN):
           //thrust -= 50;
           printf("thrust: %f\n", key);                   
      }
      key = wb_keyboard_get_key();
    }*/
    


    // Normalise
    driveL = 1;
    driveR = 1;
    
    omegaL = driveR*M_SPEED;
    omegaR = driveL*M_SPEED;  
       
   
    wb_motor_set_velocity(left_motor,  omegaL);
    wb_motor_set_velocity(right_motor, omegaR);
    wb_motor_set_velocity(back_right_motor, omegaR);
    wb_motor_set_velocity(back_left_motor, omegaL);

  };
  

  wb_robot_cleanup();

  return 0;
}
